/******************************************************************************\

  asfrecorder.c - by an unknown author, so no one is to blame.
                  Well, blame it on Microsoft.

                  Version 1.1 - Platinum Edition

                  new features:
                  -proxy and password support,
                  -a randomized client identifier (GUID),
                  -fixed problems with some asf files using partitioned headers,
                  -enhanced resume functionality to avoid broken ASF files.
                  -timecode correction for live recordings (enables seeking)

                  And that's it! This is my last ASFRecorder update!

 ------------------------------------------------------------------------------
Lives Again!
\******************************************************************************/

/* Standard ANSI-C headers */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <stdarg.h>
#include <time.h>


/* networking headers for Unix platform */
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <errno.h>

/* networking compatibility for Unix platform */
#define SOCKET int
#define SOCKET_ERROR -1
#define INVALID_SOCKET -1
typedef struct sockaddr_in SOCKADDR_IN;
#define closesocket close
/* string compatbilitiy for Unix platform */
#define stricmp strcasecmp
#define strnicmp strncasecmp




/* Prototypes for this source code module */
int main_function(int argc, char **argv);


/* largest chunk size this program can handle */
#define MAX_CHUNK_SIZE 65536


/* maximum number of URLs to handle at a time */
#define MAXURLS 100


/* The header ID to look for, all offsets relative to this ID */

unsigned char HDR_ID[16] = {0xa1,0xdc,0xab,0x8c,0x47,0xa9,0xcf,0x11,
                            0x8e,0xe4,0x00,0xc0,0x0c,0x20,0x53,0x65};

/* Offsets of some critical information in ASF header */

#define HDR_TOTAL_SIZE_8               0x28
#define HDR_NUM_PACKETS_8              0x38
#define HDR_FINE_TOTALTIME_8           0x40
#define HDR_FINE_PLAYTIME_8            0x48
#define HDR_PLAYTIME_OFFSET_4          0x50
#define HDR_FLAGS_4                    0x58
#define HDR_ASF_CHUNKLENGTH_4          0x5c
#define HDR_ASF_CHUNKLENGTH_CONFIRM_4  0x60

#define DATSEG_HDR_SIZE 0x32
#define DATSEG_NUMCHUNKS_4 0x28


/* Chunk types */

#define HEADER_CHUNK (('H' << 8) + '$')
#define DATA_CHUNK   (('D' << 8) + '$')
#define END_CHUNK    (('E' << 8) + '$')


/* The type of content on the server */
typedef enum
{
    connect_failed = 0,
    server_error,
    password_required,
    unknown_content,
    live_content,
    prerecorded_content,
    redirector_content
} ContentType;


/* a custom structure be filled with some important */
/* information about the ASF file */
struct HeaderInfo
{
    ContentType contenttype;
    unsigned int redirsize;

    unsigned int header_offs;
    unsigned int totalsize_hi, totalsize_lo;
    unsigned int totaltime_hi, totaltime_lo;
    unsigned int offset;
    unsigned int chunklength;
    unsigned int chunklength2;
    unsigned int flags;
    unsigned int endofheader_offs;

    unsigned int time;
};
